#define STRICT 1
#ifdef _MSC_VER
#pragma warning (disable : 4001 4100)
#endif
#include <windows.h>
#include <mmsystem.h>
#include <windowsx.h>
#include <vfw.h>
#include "wintoon.h"

BOOL EXPORT WINAPI ToonOnCreate(HWND hwnd, CREATESTRUCT FAR *lpCreate)
{
	return ToonCreate(hwnd, lpCreate->cx, lpCreate->cy, 0) != NULL;
}

void EXPORT WINAPI ToonOnDestroy (HWND hwnd)
{
	HTOON htoon;
	
	if ((htoon = ToonFromWindow(hwnd)) != NULL)
	{
		ToonDestroy(htoon);
	}
}

int EXPORT WINAPI ToonOnPaletteChanged (HWND hwnd, HWND hwndPaletteChanged)
{
	HTOON htoon;
		
	if ((hwnd != hwndPaletteChanged)
	&&  ((htoon = ToonFromWindow(hwnd)) != NULL))
	{
		if (ToonRealizePalette(htoon))
		{
			ToonMarkRect(htoon, NULL);
			ToonPaintRects(htoon);
		}
	}
	return 0;
}

int EXPORT WINAPI ToonOnQueryNewPalette(HWND hwnd)
{
	HTOON htoon;
	int i;

	if ((htoon = ToonFromWindow(hwnd)) == NULL)
		return 0;

	if ((i = ToonRealizePalette(htoon)) != 0)
	{
		ToonMarkRect(htoon, NULL);
		ToonPaintRects(htoon);
	}
	return i;
}

void EXPORT WINAPI ToonOnPaint(HWND hwnd)
{
	HDC hdc;
	PAINTSTRUCT ps;
	HTOON htoon;
	
	if ((htoon = ToonFromWindow(hwnd)) != NULL)
	{
		if ((hdc = BeginPaint(hwnd, &ps)) != NULL)
		{
			ToonPaintDC(htoon, hdc);
			EndPaint(hwnd, &ps);
		}
	}
}

BOOL EXPORT WINAPI ToonOnEraseBkgnd(HWND hwnd, HDC hdc)
{
	return TRUE;
}

LRESULT EXPORT CALLBACK ToonDefWindowProc(HWND hwnd, UINT message, WPARAM wparam, LPARAM lparam)
{
	switch (message)
	{
	case WM_CREATE:
		return HANDLE_WM_CREATE(hwnd, wparam, lparam, ToonOnCreate);
	case WM_DESTROY:
		return HANDLE_WM_DESTROY(hwnd, wparam, lparam, ToonOnDestroy);
	case WM_ERASEBKGND:
		return HANDLE_WM_ERASEBKGND(hwnd, wparam, lparam, ToonOnEraseBkgnd);
	case WM_PAINT:
		return HANDLE_WM_PAINT(hwnd, wparam, lparam, ToonOnPaint);
	case WM_QUERYNEWPALETTE:
		return HANDLE_WM_QUERYNEWPALETTE(hwnd, wparam, lparam, ToonOnQueryNewPalette);
	case WM_PALETTECHANGED:
		return HANDLE_WM_PALETTECHANGED(hwnd, wparam, lparam, ToonOnPaletteChanged);
	}
	return DefWindowProc(hwnd, message, wparam, lparam);
}
